PSyncPoint Class Reference

This class defines a thread synchronisation object. More...

`#include <syncpoint.h>`

Inheritance diagram for PSyncPoint:

## Public Member Functions

| PSyncPoint ()
| Create a new sync point. More...
| PSyncPoint (const PSyncPoint &)
Public Member Functions inherited from PSemaphore
unsigned | GetInitial () const
unsigned | GetMaxCount () const
| PSemaphore (unsigned initial, unsigned maximum)
| Create a new semaphore with maximum count and initial value specified. More...
| PSemaphore (const PSemaphore &)
| Create a new semaphore with the same initial and maximum values as the original. More...
| ~PSemaphore ()
| Destroy the semaphore. More...
virtual void | Wait ()
| If the semaphore count is > 0, decrement the semaphore and return. More...
virtual PBoolean | Wait (const PTimeInterval &timeout)
| If the semaphore count is > 0, decrement the semaphore and return. More...
virtual void | Signal ()
| If there are waiting (blocked) threads then unblock the first one that was blocked. More...
virtual PBoolean | WillBlock () const
| Determine if the semaphore would block if the Wait() function were called. More...
Operations
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PSemaphore
| PQUEUE (ThreadQueue, PThread)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PSemaphore
unsigned | initialVar
unsigned | maxCountVar
ThreadQueue | waitQueue

## Detailed Description

This class defines a thread synchronisation object.

This form of semaphore is used to indicate an event has occurred. A thread may block on the sync point and wait until another thread signals that it may continue. eg:

        ... thread one
        while (condition) {
          sync.Wait();
          do_something();
        }

        ... thread 2
        do_something_else();
        sync.Signal();    // At this point thread 1 wake up and does something.
        do_yet_more();

Note that events are boolean in nature. If "thread one" is not waiting on the event, multiple calls to Signal() are ignored, thread one will only exit the Wait() call a single time once it gets there. Similarly, if multiple threads are waiting on the event, only one thread will be released. As you cannot know which thread will be released this mode of use is not recommended.

## Constructor & Destructor Documentation

PSyncPoint::PSyncPoint | ( |  | ) |

Create a new sync point.

PSyncPoint::PSyncPoint | ( | const PSyncPoint & |  | ) |

The documentation for this class was generated from the following file:

- syncpoint.h